;*****SUBROUTINES***************************************************************
STKVAR1 STRUC                  ;stack variables for DoCaption
ADR1 = $
 szCaption DB 64+MAX_PATH DUP (?)
ADR2 = $
 return      DWORD ?
ADR3 = $
 hwnd        DWORD ?
 szTitleName DWORD ?
ADR4 = $
STKVAR1 ENDS

DoCaption:                     ;hwnd,szTitleName---assumed EBP=0
 SUB ESP,ADR2-ADR1             ;make local variable space

 MOV EAX,[ESP.STKVAR1.szTitleName]
 .IF !B[EAX]
   MOV EAX,@ UNTITLED
 .ENDIF

 MOV ECX,ESP                   ;ESP=ECX=&szCaption
 INVOKE wsprintf,ECX,TEXT('%s - %s',0),@ szAppName,EAX

 INVOKE SetWindowText,[ESP.STKVAR1.hwnd+1*DWORD],ESP  ;ESP=&szCaption

 ADD ESP,ADR2-ADR1             ;recover local variable space
 RET ADR4-ADR3                 ;see STKVAR1
;-------------------------------------------------------------------------------
STKVAR2 STRUC                  ;stack variables for OkMessage
ADR1 = $
 szBuffer DB 64+MAX_PATH DUP (?)
ADR2 = $
 return      DWORD ?
ADR3 = $
 hwnd        DWORD ?
 szMessage   DWORD ?
 szTitleName DWORD ?
ADR4 = $
STKVAR2 ENDS

OkMessage:                     ;hwnd,szMessage,szTitleName---assumed EBP=0
 SUB ESP,ADR2-ADR1             ;make local variable space

 MOV EAX,[ESP.STKVAR2.szTitleName]
 .IF !B[EAX]
   MOV EAX,@ UNTITLED
 .ENDIF

 MOV ECX,ESP                   ;ESP=ECX=&szBuffer=&STKVAR2n
 INVOKE wsprintf,ECX,[ECX.STKVAR2.szMessage],EAX

 MOV ECX,ESP                   ;ESP=ECX=&szBuffer=&STKVAR2
 INVOKE MessageBox,[ECX.STKVAR2.hwnd],ECX,@ szAppName,MB_OK OR MB_ICONEXCLAMATION

 ADD ESP,ADR2-ADR1             ;recover local variable space
 RET ADR4-ADR3                 ;see STKVAR2
;-------------------------------------------------------------------------------
STKVAR3 STRUC                  ;stack variables for AskAboutSave
ADR1 = $
 Buffer DB 64+MAX_PATH DUP (?)
ADR2 = $
 return      DWORD ?
ADR3 = $
 hwnd        DWORD ?
 szTitleName DWORD ?
ADR4 = $
STKVAR3 ENDS

AskAboutSave:                  ;hwnd,szTitleName---assumed EBP=0
 SUB ESP,ADR2-ADR1             ;make local variable space

 MOV EAX,[ESP.STKVAR3.szTitleName]
 .IF !B[EAX]
   MOV EAX,@ UNTITLED
 .ENDIF

 MOV ECX,ESP                   ;ESP=ECX=&szBuffer=&STKVAR3
 INVOKE wsprintf,ECX,TEXT('SAVE CURRENT CHANGES IN %s?',0),EAX

 MOV ECX,ESP                   ;ESP=ECX=&szBuffer=&STKVAR3
 INVOKE MessageBox,[ECX.STKVAR3.hwnd],ECX,@ szAppName,MB_YESNOCANCEL OR MB_ICONQUESTION

 .IF EAX==IDYES
   INVOKE SendMessage,[ESP.STKVAR3.hwnd+3*DWORD],WM_COMMAND,IDM_FILE_SAVE,EBP ;EBP=0
   .IF !EAX
     MOV EAX,IDCANCEL
   .ENDIF
 .ENDIF

 ADD ESP,ADR2-ADR1             ;recover local variable space
 RET ADR4-ADR3                 ;see STKVAR3
;-------------------------------------------------------------------------------
;-------------------------------------------------------------------------------
STKVAR10 STRUC
 return DWORD ?
ADR3 = $
 hwnd   DWORD ?
ADR4 = $
STKVAR10 ENDS

PopFileInitialize:                          ;hwnd--assume EBP=0
 MOV EAX,[ESP.STKVAR10.hwnd]
 MOV [ofn.lStructSize      ],OPENFILENAME
 MOV [ofn.hwndOwner        ],EAX
 MOV [ofn.hInstance        ],EBP            ;EBP=0
 MOV [ofn.lpstrFilter      ],@ szFilter
 MOV [ofn.lpstrCustomFilter],EBP
 MOV [ofn.nMaxCustFilter   ],EBP
 MOV [ofn.nFilterIndex     ],EBP
 MOV [ofn.lpstrFile        ],EBP            ;Set in Open and Close functions
 MOV [ofn.nMaxFile]         ,MAX_PATH
 MOV [ofn.lpstrFileTitle   ],EBP            ;Set in Open and Close functions
 MOV [ofn.nMaxFileTitle    ],MAX_PATH
 MOV [ofn.lpstrInitialDir  ],EBP
 MOV [ofn.lpstrTitle       ],EBP
 MOV [ofn.Flags            ],EBP            ;Set in Open and Close functions
 MOV D[ofn.nFileOffset]     ,EBP            ;writes next two bytes
; MOV [ofn.nFileExtension  ],0
 MOV [ofn.lpstrDefExt      ],TEXT('txt',0)
 MOV [ofn.lCustData        ],EBP
 MOV [ofn.lpfnHook         ],EBP
 MOV [ofn.lpTemplateName   ],EBP

 RET ADR4-ADR3                               ;see STKVAR10
;-------------------------------------------------------------------------------
STKVAR11 STRUC
 return DWORD ?
ADR3 = $
 hwnd          DWORD ?
 pstrFileName  DWORD ?
 pstrTitleName DWORD ?
ADR4 = $
STKVAR11 ENDS

PopFileOpenDlg:                ;hwnd,pstrFileName,pstrTitleName--assume EBP=0
 MOV EAX,[ESP.STKVAR11.hwnd]
 MOV [ofn.hwndOwner     ],EAX
 MOV [ofn.lpstrFile     ],@ szFileName
 MOV [ofn.lpstrFileTitle],@ szTitleName
 MOV [ofn.Flags         ],OFN_HIDEREADONLY OR OFN_CREATEPROMPT

 INVOKE GetOpenFileName,@ ofn

IF DBUG
 .IF !EAX
   INVOKE CommDlgExtendedError

   .IF EAX
     .IF EAX==FNERR_BUFFERTOOSMALL
       MOV EAX,TEXT('FNERR_BUFFERTOOSMALL',0)
     .ELSEIF EAX==FNERR_INVALIDFILENAME
       MOV EAX,TEXT('FNERR_INVALIDFILENAME',0)
     .ELSEIF EAX==FNERR_SUBCLASSFAILURE
       MOV EAX,TEXT('FNERR_SUBCLASSFAILURE',0)
     .ELSEIF EAX==FNERR_FILENAMECODES
       MOV EAX,TEXT('FNERR_FILENAMECODES',0)
     .ELSEIF EAX==CDERR_DIALOGFAILURE
       MOV EAX,TEXT('CDERR_DIALOGFAILURE',0)
     .ELSEIF EAX==CDERR_FINDRESFAILURE
       MOV EAX,TEXT('CDERR_FINDRESFAILURE',0)
     .ELSEIF EAX==CDERR_INITIALIZATION
       MOV EAX,TEXT('CDERR_INITIALIZATION',0)
     .ELSEIF EAX==CDERR_LOADRESFAILURE
       MOV EAX,TEXT('CDERR_LOADRESFAILURE',0)
     .ELSEIF EAX==CDERR_LOADSTRFAILURE
       MOV EAX,TEXT('CDERR_LOADSTRFAILURE',0)
     .ELSEIF EAX==CDERR_LOCKRESFAILURE
       MOV EAX,TEXT('CDERR_LOCKRESFAILURE',0)
     .ELSEIF EAX==CDERR_MEMALLOCFAILURE
       MOV EAX,TEXT('CDERR_MEMALLOCFAILURE',0)
     .ELSEIF EAX==CDERR_MEMLOCKFAILURE
       MOV EAX,TEXT('CDERR_MEMLOCKFAILURE',0)
     .ELSEIF EAX==CDERR_NOHINSTANCE
       MOV EAX,TEXT('CDERR_NOHINSTANCE',0)
     .ELSEIF EAX==CDERR_NOHOOK
       MOV EAX,TEXT('CDERR_NOHOOK',0)
     .ELSEIF EAX==CDERR_NOTEMPLATE
       MOV EAX,TEXT('CDERR_NOTEMPLATE',0)
     .ELSEIF EAX==CDERR_REGISTERMSGFAIL
       MOV EAX,TEXT('CDERR_REGISTERMSGFAIL',0)
     .ELSEIF EAX==CDERR_STRUCTSIZE
       MOV EAX,TEXT('CDERR_STRUCTSIZE',0)
     .ELSE
       MOV EAX,TEXT('UNKNOWN ERROR!',0)
     .ENDIF

    INVOKE MessageBox,ESI,EAX,EBP,EBP
    INVOKE MessageBox,ESI,TEXT('GetOpenFileName ERROR!',0),EBP,EBP
    JMP EXIT
   .ENDIF
 .ENDIF
ENDIF

 RET ADR4-ADR3                 ;see STKVAR11
;-------------------------------------------------------------------------------
STKVAR12 STRUC
 return DWORD ?
ADR3 = $
 hwnd          DWORD ?
 pstrFileName  DWORD ?
 pstrTitleName DWORD ?
ADR4 = $
STKVAR12 ENDS

PopFileSaveDlg:                ;hwnd,pstrFileName,pstrTitleName--assume EBP=0
 MOV EAX,[ESP.STKVAR12.hwnd]
 MOV [ofn.lpstrFile     ],@ szFileName
 MOV [ofn.lpstrFileTitle],@ szTitleName
 MOV [ofn.Flags         ],OFN_OVERWRITEPROMPT
 MOV [ofn.hwndOwner     ],EAX

 INVOKE GetSaveFileName,@ ofn

 RET ADR4-ADR3                 ;see STKVAR12
;-------------------------------------------------------------------------------
STKVAR4 STRUC
 EBXsave      DWORD ?
 EDIsave      DWORD ?
ADR1 = $
 iUniTest     DWORD ?
 dwBytesRead  DWORD ?
 iFileLength  DWORD ?
 pBuffer      DWORD ?
 pText        DWORD ?
 pConv        DWORD ?
ADR2 = $
 return       DWORD ?
ADR3 = $
 hwndEdit     DWORD ?
 pstrFileName DWORD ?
ADR4 = $
STKVAR4 ENDS

PopFileRead:                   ;PopFileRead--hwndEdit,pstrFileName--assume EBP=0

 SUB ESP,ADR2-ADR1             ;make local variable space
 RPUSHIT EBX,EDI               ;save registers
                               ;Open the file
 INVOKE CreateFile,[ESP.STKVAR4.pstrFileName+6*DWORD],GENERIC_READ,FILE_SHARE_READ,\
                                EBP,OPEN_EXISTING,EBP,EBP
 .IF EAX==INVALID_HANDLE_VALUE
   XOR EAX,EAX                 ;return false
   JMP PFR$RET1
 .ENDIF

 MOV EBX,EAX                   ;EBX=hFile
                               ;Get file size in bytes and allocate memory for read.
                               ;Add an extra two bytes for zero termination.
 INVOKE GetFileSize,EAX,EBP    ;EBP=0
 MOV [ESP.STKVAR4.iFileLength],EAX

 INC EAX
 INC EAX                       ;adding extra two bytes

 INVOKE LocalAlloc,LMEM_FIXED,EAX
 MOV [ESP.STKVAR4.pBuffer],EAX
                               ;Read file and put terminating zeros at end.
 LEA EAX,[ESP.STKVAR4.dwBytesRead]
 INVOKE ReadFile,EBX,[ESP.STKVAR4.pBuffer+3*DWORD],[ESP.STKVAR4.iFileLength+2*DWORD],EAX,EBP

 INVOKE CloseHandle,EBX        ;EBX=hFile

 MOV ECX,[ESP.STKVAR4.iFileLength]
 MOV [ESP.STKVAR4.iUniTest],IS_TEXT_UNICODE_SIGNATURE OR \
                   IS_TEXT_UNICODE_REVERSE_SIGNATURE
 LEA EAX,[ESP.STKVAR4.iUniTest]
 ADD ECX,[ESP.STKVAR4.pBuffer]
 MOV D[EAX],IS_TEXT_UNICODE_SIGNATURE OR IS_TEXT_UNICODE_REVERSE_SIGNATURE
 MOV W[ECX],0                  ;write double bytes to end of buffer

                               ;Test to see if the text is Unicode

 INVOKE IsTextUnicode,[ESP.STKVAR4.pBuffer+2*DWORD],[ESP.STKVAR4.iFileLength+1*DWORD],EAX ;EAX=&iUniTest

 .IF EAX                       ;is the file Unicode?
   MOV ECX,[ESP.STKVAR4.pBuffer]
   SUB [ESP.STKVAR4.iFileLength],2
   INC ECX
   INC ECX
   LEA EDX,[EBP+4]             ;EBP=0,EDX=4
   MOV [ESP.STKVAR4.pText],ECX

   .IF D[ESP.STKVAR4.iUniTest] & IS_TEXT_UNICODE_REVERSE_SIGNATURE ;
     MOV ECX,[ESP.STKVAR4.iFileLength]

     MOV EDI,[ESP.STKVAR4.pText+ECX] ;move pointer to end of file

     SHR ECX,2                 ;divide by 4
     .IF CARRY?                ;odd number of words
       DEC EDI
       DEC EDI                 ;subtract 2 from pointer to get to DWORD alignment
       ROR W[EDI],8            ;rotate bytes in odd WORD 1 2 -> 2 1
     .ENDIF

     JECXZ @F                  ;if no more DWORDs to convert

     SUB EDI,EDX               ;EDX=4,EDI points to last DWORD

     .REPEAT
       MOV EAX,[EDI]           ;read it up
       BSWAP EAX               ;swap bytes in DWORD    1 2 3 4 -> 4 3 2 1
       ROR EAX,16              ;reorder bytes in DWORD 4 3 2 1 -> 2 1 4 3
       MOV [EDI],EAX           ;write it back
       SUB EDI,EDX             ;move down to previous DWORD
      DEC ECX
     .UNTIL ZERO?              ;repeat until all DWORD converted
   .ENDIF
   @@:                         ;Allocate memory for possibly converted string
   MOV EDI,[ESP.STKVAR4.iFileLength]
   INC EDI
   INC EDI
   INVOKE LocalAlloc,LMEM_FIXED,EDI
   MOV [ESP.STKVAR4.pConv],EAX
                               ;If the edit control is not Unicode,
                               ;convert Unicode text to
                               ;non-Unicode (i.e., in general, wide character).
   IF NOT UNICODE
   INVOKE WideCharToMultiByte,EBP,EBP,[ESP.STKVAR4.pText+5*DWORD],-1,\
                               EAX,EDI,EBP,EBP ;EBP=CP_ACP
   ELSE                           ;If the control is Unicode, just copy the string.
   INVOKE lstrcpy,[ESP.STKVAR4.pConv+1*DWORD],[ESP.STKVAR4.pText]
   ENDIF
 .ELSE                         ;the file is not Unicode
   MOV EAX,[ESP.STKVAR4.iFileLength]
   MOV ECX,[ESP.STKVAR4.pBuffer]
   LEA EAX,[2*EAX+2]
   MOV [ESP.STKVAR4.pText],ECX
                               ;Allocate memory for possibly converted string.
   INVOKE LocalAlloc,LMEM_FIXED,EAX
   MOV [ESP.STKVAR4.pConv],EAX
                               ;If the edit control is Unicode, convert ASCII text.
   IF UNICODE
   MOV EAX,[ESP.STKVAR4.iFileLength]
   INC EAX
   INVOKE MultiByteToWideChar,EBP,EBP,[ESP.STKVAR4.pText+3*DWORD],-1,\
                                      [ESP.STKVAR4.pConv+1*DWORD],EAX ;EBP=CP_ACP
   ELSE                           ;If not, just copy buffer
   INVOKE lstrcpy,[ESP.STKVAR4.pConv+1*DWORD],[ESP.STKVAR4.pText]
   ENDIF
 .ENDIF

 INVOKE SetWindowText,[ESP.STKVAR4.hwndEdit+1*DWORD],[ESP.STKVAR4.pConv]

 INVOKE LocalFree,[ESP.STKVAR4.pBuffer]
 INVOKE LocalFree,[ESP.STKVAR4.pConv]

 MOV EAX,ESI                   ;ESI=TRUE
PFR$RET1:
 POPIT EBX,EDI                 ;restore registers
 ADD ESP,ADR2-ADR1             ;recover local variable space
 RET ADR4-ADR3                 ;see STKVAR4
;-------------------------------------------------------------------------------
STKVAR5 STRUC
 EBXsave        DWORD ?
 EDIsave        DWORD ?
ADR1 = $
 iUniTest       DWORD ?
 wByteOrderMark DWORD ?
 dwBytesWritten DWORD ?
 iFileLength    DWORD ?
 pstrBuffer     DWORD ?
 pText          DWORD ?
 pConv          DWORD ?
ADR2 = $
 return         DWORD ?
ADR3 = $
 hwndEdit       DWORD ?
 pstrFileName   DWORD ?
ADR4 = $
STKVAR5 ENDS

PopFileWrite:                  ;--hwndEdit,pstrFileName--assume EBP=0
 SUB ESP,ADR2-ADR1             ;make local storage
 RPUSHIT EBX,EDI               ;save registers

 MOV [ESP.STKVAR5.wByteOrderMark],0FEFFH
                               ;Open the file, creating it if necessary
 INVOKE CreateFile,[ESP.STKVAR5.pstrFileName+6*DWORD],GENERIC_WRITE,EBP,EBP,CREATE_ALWAYS,EBP,EBP
 MOV EDI,EAX                   ;EDI=hFile

 .IF EAX==INVALID_HANDLE_VALUE
   XOR EAX,EAX                 ;return FALSE
   JMP RET2
 .ENDIF
                               ;Get the number of characters in the edit control
                               ;and allocate memory for them.
 INVOKE GetWindowTextLength,[hwndEdit]
 MOV EBX,EAX                   ;EBX=iLength

 INC EAX

IF UNICODE
 SHL EAX,1
ENDIF

 INVOKE LocalAlloc,LMEM_FIXED,EAX
 MOV [ESP.STKVAR5.pstrBuffer],EAX

 .IF !EAX
   INVOKE CloseHandle,EDI

   XOR EAX,EAX                 ;FALSE
   JMP RET2
 .ENDIF
                               ;If the edit control will return Unicode Text,
                               ;write the byte order mark to the file.
IF UNICODE
 LEA EAX,[ESP.STKVAR5.dwBytesWritten]
 LEA ECX,[ESP.STKVAR5.wByteOrderMark]
 INVOKE WriteFile,EDI,ECX,2,EAX,EBP
ENDIF
                               ;Get the edit buffer and write that out to the file.
 MOV EAX,EBX
 INC EAX

 INVOKE GetWindowText,[hwndEdit],[ESP.STKVAR5.pstrBuffer+1*DWORD],EAX

 MOV EAX,EBX                   ;EBX=iLength

IF UNICODE
 SHL EAX,1
ENDIF

 LEA ECX,[ESP.STKVAR5.dwBytesWritten]
 INVOKE WriteFile,EDI,[ESP.STKVAR5.pstrBuffer+3*DWORD],EAX,ECX,EBP

 INVOKE CloseHandle,EDI
 INVOKE LocalFree,[ESP.STKVAR5.pstrBuffer]

 MOV EAX,ESI                   ;return TRUE

 .IF EBX != [ESP.STKVAR5.dwBytesWritten]
   XOR EAX,EAX                 ;return FALSE
 .ENDIF

RET2:
 POPIT EBX,EDI                 ;restore registers
 ADD ESP,ADR2-ADR1             ;recover local variable space
 RET ADR4-ADR3                 ;see STKVAR5
;-------------------------------------------------------------------------------
STKVAR13 STRUC
 return DWORD ?
ADR3 = $
 hwnd          DWORD ?
ADR4 = $
STKVAR13 ENDS

PopFindFindDlg:                ;hwnd--assume EBP=0

 MOV [fr.lStructSize     ],FINDREPLACE
 MOV EAX,[ESP.STKVAR13.hwnd]
 MOV [fr.hInstance       ],EBP
 MOV [fr.Flags           ],FR_HIDEUPDOWN OR FR_HIDEMATCHCASE OR FR_HIDEWHOLEWORD
 MOV [fr.lpstrFindWhat   ],@ szFindText
 MOV [fr.lpstrReplaceWith],EBP
 MOV [fr.wFindWhatLen    ],MAX_PATH
 MOV [fr.wReplaceWithLen ],0
 MOV [fr.lCustData       ],EBP
 MOV [fr.lpfnHook        ],EBP
 MOV [fr.lpTemplateName  ],EBP
 MOV [fr.hwndOwner       ],EAX

 INVOKE FindText,@ fr

 RET ADR4-ADR3                 ;see STKVAR13
;-------------------------------------------------------------------------------
STKVAR14 STRUC
 return DWORD ?
ADR3 = $
 hwnd          DWORD ?
ADR4 = $
STKVAR14 ENDS

PopFindReplaceDlg:             ;hwnd--assume EBP=0
 MOV [fr.lStructSize     ],FINDREPLACE
 MOV EAX,[ESP.STKVAR14.hwnd]
 MOV [fr.hInstance       ],EBP
 MOV [fr.Flags           ],FR_HIDEUPDOWN OR FR_HIDEMATCHCASE OR FR_HIDEWHOLEWORD
 MOV [fr.lpstrFindWhat   ],@ szFindText
 MOV [fr.lpstrReplaceWith],@ szReplText
 MOV [fr.wFindWhatLen    ],MAX_PATH
 MOV [fr.wReplaceWithLen ],MAX_PATH
 MOV [fr.lCustData       ],EBP
 MOV [fr.lpfnHook        ],EBP
 MOV [fr.lpTemplateName  ],EBP
 MOV [fr.hwndOwner       ],EAX

 INVOKE ReplaceText,@ fr

 RET ADR4-ADR3                 ;see STKVAR14
;-------------------------------------------------------------------------------
STKVAR7 STRUC
 EBXsave        DWORD ?
 EDIsave        DWORD ?
 return         DWORD ?
ADR3 = $
 hwndEdit       DWORD ?
 piSearchOffset DWORD ?
 pfr            DWORD ?
ADR4 = $
STKVAR7 ENDS

PopFindFindText:               ;hwndEdit,pSearchOffset,pfr
 RPUSHIT EBX,EDI               ;save registers
                               ;Read in the edit document
 INVOKE GetWindowTextLength,[ESP.STKVAR7.hwndEdit]
 MOV EBX,EAX                   ;EBX=iLength
 INC EAX

IF UNICODE
 SHL EAX,1
ENDIF

 INVOKE LocalAlloc,LMEM_FIXED,EAX
 MOV EDI,EAX                   ;EDI=pstrDoc

 TEST EAX,EAX
 JZ PFFT$1                     ;return FALSE

 LEA EAX,[EBX+1]               ;EBP=0,EAX=1

 INVOKE GetWindowText,[ESP.STKVAR7.hwndEdit+2*DWORD],EDI,EAX
                               ;Search the document for the find string
 MOV ECX,[ESP.STKVAR7.piSearchOffset]
 MOV EAX,EDI                   ;EDI=EAX=pstrDoc
 MOV EDX,[ESP.STKVAR7.pfr]
 ADD EAX,[ECX]

 INVOKIT strstr,EAX,[EDX.FINDREPLACE.lpstrFindWhat]

 MOV EBX,EAX                   ;EBX=pstrPos=start address of found string

 INVOKE LocalFree,EDI          ;EDI=pstrDoc
                               ;Return an error code if the string cannot be found
 .IF !EBX                      ;EBX=pstrPos=start address of found string
   XOR EAX,EAX
   JMP PFFT$1
 .ENDIF
                               ;Find the position in the document and the new start offset
 SUB EBX,EDI                   ;EBX=iPos=start position of found string
 MOV EDX,[ESP.STKVAR7.pfr]     ;EDX=&FR
 PUSH EBP                      ;***push for second SendMessage below,EBP=0

 INVOKE lstrlen,[EDX.FINDREPLACE.lpstrFindWhat]

 PUSH EBP                      ;***push for second SendMessage below,EBP=0
 PUSH EM_SCROLLCARET           ;***push for second SendMessage below
 ADD EAX,EBX                   ;EAX=end position of found string
 MOV ECX,[ESP.STKVAR7.piSearchOffset+3*DWORD]
 PUSH [ESP.STKVAR7.hwndEdit+3*DWORD] ;***push for second SendMessage below
 MOV [ECX],EAX
                               ;Select the found text
 INVOKE SendMessage,[ESP.STKVAR7.hwndEdit+7*DWORD],EM_SETSEL,EBX,EAX
 INVOKIT SendMessage           ;last four parameters already pushed above

 MOV EAX,ESP                   ;return ESP=TRUE

PFFT$1:
 POPIT EBX,EDI                 ;restore registers
 RET ADR4-ADR3                 ;see STKVAR7
;-------------------------------------------------------------------------------
STKVAR6 STRUC
 return         DWORD ?
ADR3 = $
 hwndEdit       DWORD ?
 piSearchOffset DWORD ?
ADR4 = $
STKVAR6 ENDS

PopFindNextText:               ;hwndEdit,piSearchOffset
 MOV [fr.lpstrFindWhat],@ szFindText

 INVOKIT PopFindFindText,[ESP.STKVAR6.hwndEdit+2*DWORD],\
                         [ESP.STKVAR6.piSearchOffset+1*DWORD],@ fr

 RET ADR4-ADR3                 ;see STKVAR6
;-------------------------------------------------------------------------------
STKVAR8 STRUC
 return         DWORD ?
ADR3 = $
 hwndEdit       DWORD ?
 piSearchOffset DWORD ?
 pfr            DWORD ?
ADR4 = $
STKVAR8 ENDS

PopFindReplaceText:            ;hwndEdit,piSearchOffset,pfr--assume EBP=0
                               ;Find the text
 INVOKIT PopFindFindText,[ESP.STKVAR8.hwndEdit+2*DWORD],\
                         [ESP.STKVAR8.piSearchOffset+1*DWORD],[ESP.STKVAR8.pfr]

 TEST EAX,EAX
  JZ @F                        ;return FALSE
                               ;replace it
 MOV EDX,[ESP.STKVAR8.pfr]
 INVOKE SendMessage,[ESP.STKVAR8.hwndEdit+3*DWORD],EM_REPLACESEL,EBP,[EDX.FINDREPLACE.lpstrReplaceWith] ;EBP=0

 MOV EAX,ESI                   ;ESI=TRUE
@@:
 RET ADR4-ADR3                 ;see STKVAR8
;-------------------------------------------------------------------------------
STKVAR9 STRUC
ADR1 = $
 cf CHOOSEFONT {}
ADR2 = $
 return DWORD ?
ADR3 = $
 hwnd   DWORD ?
ADR4 = $
STKVAR9 ENDS

PopFontChooseFont:             ;hwnd--assume EBP=0
 SUB ESP,ADR2-ADR1
 MOV EAX,[ESP.STKVAR9.hwnd]
 MOV [ESP.STKVAR9.cf.lStructSize    ],CHOOSEFONT
 MOV [ESP.STKVAR9.cf.hwndOwner      ],EAX
 MOV [ESP.STKVAR9.cf.hDC            ],EBP
 MOV [ESP.STKVAR9.cf.lpLogFont      ],@ logfont
 MOV [ESP.STKVAR9.cf.iPointSize     ],EBP
 MOV [ESP.STKVAR9.cf.Flags          ],CF_INITTOLOGFONTSTRUCT OR CF_SCREENFONTS OR CF_EFFECTS
 MOV [ESP.STKVAR9.cf.rgbColors      ],EBP
 MOV [ESP.STKVAR9.cf.lCustData      ],EBP
 MOV [ESP.STKVAR9.cf.lpfnHook       ],EBP
 MOV [ESP.STKVAR9.cf.lpTemplateName ],EBP
 MOV [ESP.STKVAR9.cf.hInstance      ],EBP
 MOV [ESP.STKVAR9.cf.lpszStyle      ],EBP

 INVOKE ChooseFont,ESP ;ESP=&cf

 ADD ESP,ADR2-ADR1
 RET ADR4-ADR3                 ;see STKVAR9
;-------------------------------------------------------------------------------
STKVAR17 STRUC
 return DWORD   ?
ADR3 = $
 hwndEdit DWORD ?
ADR4 = $
STKVAR17 ENDS

PopFontInitialize:
 INVOKE GetStockObject,SYSTEM_FONT
 INVOKE GetObject,EAX,LOGFONT,@ logfont

 INVOKE CreateFontIndirect,@ logfont
 MOV [hFont],EAX

 INVOKE SendMessage,[ESP.STKVAR17.hwndEdit+3*DWORD],WM_SETFONT,[hFont],EBP

 RET ADR4-ADR3
;-------------------------------------------------------------------------------
STKVAR16 STRUC
ADR1 = $
 rect RECT {}
 hFontNew DWORD ?
ADR2 = $
 return   DWORD ?
ADR3 = $
 hwndEdit DWORD ?
ADR4 = $
STKVAR16 ENDS

PopFontSetFont:
 SUB ESP,ADR2-ADR1

 INVOKE CreateFontIndirect,@ logfont
 MOV EBX,EAX              ;EBX=ESP=&hFontNew

 INVOKE SendMessage,[ESP.STKVAR16.hwndEdit+3*DWORD],WM_SETFONT,EBX,EBP

 INVOKE DeleteObject,[hFont]

 LEA ECX,[ESP.STKVAR16.rect]
 MOV [hFont],EBX

 INVOKE GetClientRect,[ESP.STKVAR16.hwndEdit+1*DWORD],ECX

 MOV ECX,ESP                ;ESP=&rect
 INVOKE InvalidateRect,[ESP.STKVAR16.hwndEdit+2*DWORD],ECX,ESI ;ESI=TRUE

 ADD ESP,ADR2-ADR1
 RET ADR4-ADR3
;-------------------------------------------------------------------------------
PopPrntPrintFile:           ;dummy
  XOR EAX,EAX
 RET
;-------------------------------------------------------------------------------
STKVAR15 STRUC
 regsave DWORD 4 DUP (?)
 return  DWORD ?
ADR3 = $
 iBuffer DWORD ?
 iWhat   DWORD ?
ADR4 = $
STKVAR15 ENDS

strstr:                        ;iBuffer,iWhat
 PUSHIT EBX,EBP,ESI,EDI        ;save 4 registers

 MOV EBP,[ESP.STKVAR15.iBuffer]       ;EBP=beginning of string to search

 INVOKE lstrlen,EBP
 MOV EBX,EAX                   ;EBX=length of string to search

 INVOKE lstrlen,[ESP.STKVAR15.iWhat]
 MOV EDX,EAX                   ;EDX=length of string to match

 .IF (EBX < EDX) || !EDX       ;return NULL if search string length < match string length
   XOR EAX,EAX                 ;or search string length is zero
   JMP @F
 .ENDIF

 SUB EBX,EDX                   ;determine how many characters to match with compare bytre
 DEC EDX                       ;adjustment
 INC EBX                       ;adjust how many characters to match

 .REPEAT
   MOV ESI,[ESP.STKVAR15.iWhat] ;address of matching string
   MOV EDI,EBP                 ;pointer to remainder of string to search
   MOV ECX,EBX
   LODSB
   REPNE SCASB

   .IF !ZERO?
     XOR EAX,EAX
     JMP @F                    ;return NULL, StrAdr1 does not match
   .ENDIF

   MOV EBX,ECX                 ;save count for remainder of string to search
   MOV EBP,EDI                 ;save position + 1 of find

   MOV ECX,EDX                 ;ECX=count of string to match
   JECXZ strstr$1              ;leave loop is comparision is complete
   REPE CMPSB
 .UNTIL ZERO?                  ;exit loop if string matches

strstr$1:
 LEA EAX,[EBP-1]               ;adjust pointer to beginning of match
@@:
 POPIT EDI,ESI,EBP,EBX         ;restore 4 registers
 RET ADR4-ADR3                 ;see STKVAR15
;*****END OF SUBROUTINES********************************************************
